#!/usr/local/bin/perl -T
use strict;

my $value = shift;

if (is_tainted($value)) {
    print "\$value is tainted.\n";
}

$value = untaint(qr/([a-z]+)/, $value);

# perldoc perlsec
sub is_tainted {
    return ! eval {
        join('', @_), kill 0;
        1;
    };
}

sub untaint {
    my($re, $value) = @_;
    if ($value =~ /$re/) {
        return $1;
    } else {
        die "untaint failed for $value";
    }
}

